#include "cora_fit.h"
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <math.h>

/* ------------------------ */

double sbgfunc(double * p_vec, int * N)

{
/* static FILE *fd; */

 int i,j,chicount=0;
 double chi2=0., dummy, chitemp;
 static Vector good_err;
 static int init;
 static float * chi;

 if (init == 0)
  {
/*fd=fopen("test.dat","w");*/
    vec_init (&good_err);
    vec_alloc(&good_err,  x.len);
    sel_vals (&good_err,  &err,  &good);
    chi   = (float *) malloc (sizeof(float) * x.len);
    init=1;
  }

 sbg=p_vec[0];

for (i = 0; i < count; ++i) bbb.vec[i] += sbg;

    dummy = func_testlik(&(startP));

for (i = 0; i < count; ++i)  bbb.vec[i] -= sbg;

/* dummy = callik(); */

  for (i = 0; i < count; ++i)
    {
      chi[i] = 0.0;
      for (j = 0; j < nlines; ++j)
         chi[i] += yc[j][i] * ampout.vec[j];
      chi[i] += bbb.vec[i]+sbg;
    }

/*  if (init == 0) {
	for (i=0;i<count;++i) fprintf(fd,"%f %f\n",x.vec[i],chi[i]);
        init=1;
	fclose(fd);
	fd=fopen("test2.dat","w");
	for (i=0;i<count;++i) fprintf(fd,"%f %f\n",x.vec[i],ncount.vec[i]);
	fclose(fd);}
 */

  for (i = 0; i < count; ++i)
    {
      if (good_err.vec[i] > 0.0)
        {
          ++chicount;
          chitemp = (chi[i]-ncount.vec[i]);
          chi2 += (chitemp * chitemp)/(good_err.vec[i] * good_err.vec[i]); 
        }
    }
  if (chicount>0) chi2 /= chicount; else chi2 = -1.;

/* fprintf(stderr,"%f %f %d %d %f %f\n",sbg,chi2,chicount,x.len,x.vec[0],x.vec[count-1]); */

 return(chi2);

}

/* ------------------------ */

double sbgiterate(Vector *sarr, double sbgmed)
{

  /*  determine source background by median (lines excluded)  */
  /*  eventually do a Chi^2 iteration in addition */
  
  int csel,nstep=15,lsel,i,j;
  Vector test,sel,test1;
  double minsbg,sbgmax,sbgmin;
  
  if (verbose)
   printf("Message      : Determining source background\n");

  lsel=sarr->len;
  sbgmax = sbgmed+medsig*sqrt(sbgmed);
  where(&sel, sarr, func_lt, &sbgmax, &csel);
  if (csel > 0)
    {
     vec_init(&test);
     vec_alloc(&test, csel);

     sel_vals(&test, sarr, &sel);
     sbgmed = median(&test);
    }

  j=0; 
  while (csel > 0 && csel < lsel && j < nstep)
   {
     ++j;
     lsel = csel;
     sbgmax = sbgmed+medsig*sqrt(sbgmed);
     where(&sel, &test, func_lt, &sbgmax, &csel);
     if (csel > 0)
      {
       vec_init(&test1);
       vec_alloc(&test1, csel);
       sel_vals(&test1, &test, &sel);
       sbgmed = median(&test1); 
       vec_free(&test);
       vec_init(&test);
       vec_alloc(&test,csel);
	for (i=0;i<csel;++i) test.vec[i]=test1.vec[(int)sel.vec[i]];
       vec_free(&test1);
      }
    }

  if (sbgchi == 1)
   {
    vec_init(&test);
    vec_alloc(&test,1);
    test.vec[0]=sbgmed-1;

    if (verbose)
	printf("Message      : Iterating sbg with Chi^2\n");
/*    powell(&(test.vec[0]), test.len,1.0e-6,&minsbg,sbgfunc,.1); */

    sbgmin = MinFinder (&(test.vec[0]), 0., sbgmax,1.0e-4,&minsbg,sbgfunc);
    /* if (test.vec[0] < sbgmed) */
    sbgmed = test.vec[0];
    vec_free(&test);
   }

  return(sbgmed);
}

/* ------------------------ */

void smoothbg()
{

  int bg_dg = 2;
  double mB = -1.;
  int i;

  /*  smooth background vector bkgd with m-order polonomial  */   
      if (verbose)
	printf("Message      : Smoothing instrumental background\n");
      while(mB < 0.0 && bg_dg >= 0)
        {
          poly_fit(&x,&bb0,&bbb,bg_dg);
          mB=min(&bbb);
          if(mB > 0.0)
            for(i=0; i < count; ++i) 
              bkgd.vec[(int)good.vec[i]]=bbb.vec[i];
          else bg_dg = bg_dg-1;
        }
     if(bg_dg < 2 && bg_dg >= 0)
       {
         fprintf(stderr, "*  Warning  *: Could not smooth background with "\
                 "2nd order polonomial,\n");
         fprintf(stderr,
		 "*              using polonomial of order %d instead.\n",
                 bg_dg);
       }
     else if(bg_dg < 0)
       {
         fprintf(stderr, "*  Warning  *: Could not smooth background,\n");
         fprintf(stderr, 
		 "               using original background instead.\n");
       }

    if (verbose>1)
      printf("Message      : bg_instr = [%f..%f] cts/bin\n",min(&bbb),max(&bbb));

 return;
}

